//
//  SaveFloat4PlugIn.m
//  SaveFloat4
//
//  Created by Dustin O'Connor on 4/8/12.
//  Copyright (c) 2012 d0cut0uch. All rights reserved.
//

// It's highly recommended to use CGL macros instead of changing the current context for plug-ins that perform OpenGL rendering
#import <OpenGL/CGLMacro.h>

#import "SaveFloat4PlugIn.h"

#define	kQCPlugIn_Name				@"SaveFloat4"
#define	kQCPlugIn_Description		@"SaveFloat4 description"

@implementation SaveFloat4PlugIn

@dynamic inputWrite;
@dynamic inputPath;
@dynamic inputStructure;
@synthesize index;

// Here you need to declare the input / output properties as dynamic as Quartz Composer will handle their implementation
//@dynamic inputFoo, outputBar;

+ (NSDictionary *)attributes
{
	// Return a dictionary of attributes describing the plug-in (QCPlugInAttributeNameKey, QCPlugInAttributeDescriptionKey...).
	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary *)attributesForPropertyPortWithKey:(NSString *)key
{
	// Specify the optional attributes for property based ports (QCPortAttributeNameKey, QCPortAttributeDefaultValueKey...).
	return nil;
}

+ (QCPlugInExecutionMode)executionMode
{
	// Return the execution mode of the plug-in: kQCPlugInExecutionModeProvider, kQCPlugInExecutionModeProcessor, or kQCPlugInExecutionModeConsumer.
	return kQCPlugInExecutionModeConsumer;
}

+ (QCPlugInTimeMode)timeMode
{
	// Return the time dependency mode of the plug-in: kQCPlugInTimeModeNone, kQCPlugInTimeModeIdle or kQCPlugInTimeModeTimeBase.
	return kQCPlugInTimeModeNone;
}

- (id)init
{
	self = [super init];
	if (self) {
    
        index =[[[NSMutableArray alloc]initWithCapacity:10]autorelease];
	}
	
	return self;
}


@end

@implementation SaveFloat4PlugIn (Execution)

- (BOOL)startExecution:(id <QCPlugInContext>)context
{
	// Called by Quartz Composer when rendering of the composition starts: perform any required setup for the plug-in.
	// Return NO in case of fatal failure (this will prevent rendering of the composition to start).
	
	return YES;
}

- (void)enableExecution:(id <QCPlugInContext>)context
{
	// Called by Quartz Composer when the plug-in instance starts being used by Quartz Composer.
}

- (BOOL)execute:(id <QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary *)arguments
{
	if(self.inputWrite)
    {
        NSString * error;
		
        
        id plist = [NSPropertyListSerialization dataFromPropertyList:(id)self.inputStructure
                                                              format:NSPropertyListXMLFormat_v1_0 errorDescription:&error];
        
        
        if(plist) {
            NSLog(@"No error creating XML data.");
            [plist writeToFile:self.inputPath atomically:YES];
        }
        else {
           NSLog(@"Yes error creating XML data. %@",error);
            [error release];
        }

        
    }
	
	return YES;
}

- (void)disableExecution:(id <QCPlugInContext>)context
{
	// Called by Quartz Composer when the plug-in instance stops being used by Quartz Composer.
}

- (void)stopExecution:(id <QCPlugInContext>)context
{
	// Called by Quartz Composer when rendering of the composition stops: perform any required cleanup for the plug-in.
}

@end
